import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class Balls 
{
	public static void main(String[] args) throws Exception 
	{
		new Balls().run();
	}
	
	private class Ball 
	{
		final double x,y,z,r;
		public Ball(double xx, double yy, double zz, double rr)
		{
			x = xx;
			y = yy;
			z = zz;
			r = rr;
		}
		
		public boolean intersect(Ball b)
		{
			double dx = b.x-x;
			double dy = b.y-y;
			double dz = b.z-z;
			double rr = b.r+r;
			return (dx * dx + dy * dy + dz * dz) < (rr * rr);
		}
	}
	
	private StreamTokenizer in;
	private PrintWriter out;

	private double nextDouble() throws Exception 
	{
		in.nextToken();
		return (double)in.nval;
	}

	private int nextInt() throws Exception 
	{
		in.nextToken();
		return (int)in.nval;
	}
	
	private void run() throws Exception
	{
		in = new StreamTokenizer(new BufferedReader(new FileReader("balls.in")));
		//out = new PrintWriter("balls.out");
		out = new PrintWriter(new OutputStreamWriter(System.out));
		
		solve();
		
        out.flush();
        out.close();
	}
	
	void solve() throws Exception 
	{
		int testn = nextInt();
		for (int testi = 0; testi < testn; testi++)
		{
			List<Ball> cross = new ArrayList<Ball>();
			List<Ball> noCross = new ArrayList<Ball>();
			List<Ball> balls = new ArrayList<Ball>();
			
			noCross.add(new Ball(nextDouble(), nextDouble(), nextDouble(), nextDouble()));			
			
			int n = nextInt();
			for(int i = 0; i < n; i++)
			{
				balls.add(new Ball(nextDouble(), nextDouble(), nextDouble(), nextDouble()));
			}
			
			int result = 0;
			for(int i = 0; i < n; i++)
			{
				Ball testBall = balls.get(i);
				List<Ball> newCross = new ArrayList<Ball>();
				for (Ball curBall : noCross)
				{
					if(testBall.intersect(curBall))
					{
						newCross.add(curBall);
					}
				}
				if(newCross.size() > 0)
				{
					cross.add(testBall);
					cross.addAll(newCross);
					noCross.removeAll(newCross);
				}
				else
				{
					boolean isCrossing = false;
					for(Ball curBall : cross)
					{
						if(curBall.intersect(testBall)) 
						{
							isCrossing = true;
							break;
						}
					}
					if (isCrossing)
					{
						cross.add(testBall);
					}
					else
					{
						noCross.add(testBall);
					}
				}
				if (noCross.size() == 0)
				{
					result = i + 1;
					break;
				}
			}
			out.println(result);
		}
	}
}
