#include <iostream>
#include <cmath>
#include <deque>

using namespace std;

struct Ball
{
    double x,y,z,r;
	
	bool intersect(Ball &b)
	{
		double dx = b.x - x;
		double dy = b.y - y;
		double dz = b.z - z;
		return sqrt(dx * dx + dy * dy + dz * dz) < (r + b.r);
	}
};

int main()
{
	freopen("balls.in", "rt", stdin);
	//freopen("balls.out", "wt", stdout);

	int testn;
	scanf("%d", &testn);

	for (int testi = 0; testi < testn; testi++)
	{
		Ball tempBall;
		deque<Ball> crossBalls, noCrossBalls, balls;
		cin >> tempBall.x >> tempBall.y >> tempBall.z >> tempBall.r;
		//scanf("%lf%lf%lf%lf", &tempBall.x, &tempBall.y, &tempBall.z, &tempBall.r);
		noCrossBalls.push_back(tempBall);

		int n;
		cin >> n;
		for(int i = 0; i < n; i++)
		{
			cin >> tempBall.x >> tempBall.y >> tempBall.z >> tempBall.r;
			//scanf("%lf%lf%lf%lf", &tempBall.x, &tempBall.y, &tempBall.z, &tempBall.r);
			balls.push_back(tempBall);	
		}
			
		int result = 0;

		for(int i = 0; i < n; i++)
		{
			Ball testBall = balls[i];

			int noCrossIndex = 0;
			bool hasCrossNC = false;
			while ((noCrossBalls.size() > 0) && (noCrossIndex < noCrossBalls.size()))
			{
				Ball curBall = noCrossBalls[noCrossIndex];
				if (testBall.intersect(curBall))
				{
					hasCrossNC = true;
					crossBalls.push_back(curBall);
					noCrossBalls.erase(noCrossBalls.begin() + noCrossIndex);
				}
				else
				{
					noCrossIndex++;
				}
			}

			if (hasCrossNC)
			{
				crossBalls.push_back(testBall);
			}
			else
			{
				int crossIndex = 0;
				bool hasCrossC = false;
				while (crossIndex < crossBalls.size())
				{
					Ball curBall = crossBalls[crossIndex];
					if (testBall.intersect(curBall))
					{
						hasCrossC = true;
						crossBalls.push_back(testBall);
						break;
					}
					else
					{
						crossIndex++;
					}
				}
				if (!hasCrossC)
				{
					noCrossBalls.push_back(testBall);
				}
			}
	
			if (noCrossBalls.size() == 0)
			{
				result = i + 1;
				break;
			}
		}
		cout << result << endl;
	}

  return 0;
}

